// Beph 1.0v2
// Vikram Kulkarni
// BephView.h

#ifndef _BEPHVIEWS_H_
#define _BEPHVIEWS_H_

#include <Application.h>
#include <InterfaceKit.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "VStatusBar.h"

#ifdef _PH_SERVERS_H_
extern const int NUMBER_OF_SERVERS_IN_LIST;
extern char *servers_type[NUMBER_OF_SERVERS_IN_LIST * 2];
#endif

#ifndef _PH_SERVERS_H_
#define _PH_SERVERS_H_
#include "ph_servers.h"
#endif

//class BephMenuView;
//class BephQueryView;
//class BephOutputView;

// None of these classes are absolutely needed...
// I could have added the individual components to the window directly
// but I think this makes the code easier to deal with.

/*------------------------------------------------------------------*/
class BephMenuView : public BMenuBar
{
	public:
		BephMenuView(BRect frame);
};

/*------------------------------------------------------------------*/
class BephQueryView : public BBox
{
	// BephWindow is a friend so it can read/write directly
	// to/from the views without me having to write alot of code...
	friend class BephWindow;
	
	public:
		BephQueryView(BRect frame, char *server);
		~BephQueryView();
		
		BPopUpMenu * BuildServerMenu(char *server);
	
	private:
		// the actual ph query
		BTextControl	*inputView;
		// the return all check box
		BCheckBox		*checkBox;
		// the server
		BTextControl	*serverView;
		// the server menu
		BMenuField		*serverList;
		// the submit button
		BButton			*button;
		// show/hide the text area
		BPictureButton	*show_hide_button;
};

/*------------------------------------------------------------------*/
class BephOutputView : public BView
{
	// BephWindow is a friend so it can read/write directly
	// to/from the views without me having to write alot of code...
	friend class BephWindow;
	
	public:
		BephOutputView(BRect frame);
		virtual void AttachedToWindow();
	private:
		// the actual ph reply will go here...
		BTextView		*outputTextView;
		// add's scroll bars...
		BScrollView 	*scrollView;
		// shows the current status
		BStringView		*statusView;
		BBox			*status_border;
		// Progress Bar
		VStatusBar		*statusBar;
};

#endif