// Beph 1.0v2
// Vikram Kulkarni
// BephWindow.h

#ifndef _BEPHWINDOW_H_
#define _BEPHWINDOW_H_

#include <Window.h>
#include <string.h>
#include "BephViews.h"
#include "BephNet.h"
#include "BephParser.h"
#include "TPreferences.h"


//class BephWindow;

class BephWindow : public BWindow
{
	public:
		BephWindow(BRect frame, char *Server);
		~BephWindow();
		void MessageReceived(BMessage *msg);
		virtual bool QuitRequested();
		
	private:
		// finds the ph server name given the location
		char *FindServer(const char *Location_Name);
		// 
		void SetLocation_Name(const char *Server);

		// all network transactions go through this
		BephNet				*netReq;
		// this cleanes up the server reply
		BephParser			*parser;
		// See BephViews.*
		BephMenuView		*menuView;
		BephQueryView		*queryView;
		BephOutputView		*outputView;
		
		// can't do more than one request at a time
		bool				request_active;
		// is Beph adding 'alias =' to the request
		bool				alias_equals;
		// is the return all box checked?
		bool				return_all;
		// is the text area shown
		bool				output_view_shown;
		// the ph server
		char				*server;
		// how many lines returned
		int					lines;
		// Old Window Size (if views are hidden)
		BRect				old_size;
		// The min and max size... so I don't have to recalc them
		float				min_height;
		float				max_height;
};

#endif