//************************************************
//
//	VStatusBar.h
//	A status bar class with no text labels.
//  Vikram Kulkarni
//	Copyright 1997
//
//************************************************
//
//  Very similar to BStatusBar...
//  BStatusBar:
//		Copyright 1996-97, Be Incorporated
//
//************************************************


#ifndef	_V_STATUS_BAR_H
#define	_V_STATUS_BAR_H

#include <View.h>

class VStatusBar : public BView {

public:
						VStatusBar(	BRect frame,
									const char *name,
									uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP,
									uint32 flags = B_WILL_DRAW | B_FULL_UPDATE_ON_RESIZE);
						VStatusBar(BMessage *data);
						~VStatusBar();
	static	VStatusBar	*Instantiate(BMessage *data);
	virtual	status_t	Archive(BMessage *data, bool deep = true) const;

	
	virtual	void		AttachedToWindow();
	virtual	void		MessageReceived(BMessage *msg);
	virtual	void		Draw(BRect updateRect);
	
	virtual	void		SetBarColor(rgb_color color);
	virtual	void		SetBarHeight(float height);
	virtual	void		SetMaxValue(float max);
	
	virtual	void		Update(	float delta );
	virtual	void		Reset();
	
	float				CurrentValue() const;
	float				MaxValue() const;
	rgb_color			BarColor() const;
	float				BarHeight() const;

private:
	
	float				fMax;
	float				fCurrent;
	float				fBarHeight;
	rgb_color			fBarColor;
	rgb_color			fLightBarColor;
	rgb_color			fDarkBarColor;
	rgb_color			fDarkGrey;
	rgb_color			fLightGrey;
	rgb_color			fMedGrey;
	
};

#endif
