// Beph 1.2.1
// Vikram Kulkarni
// Beph.cpp

#include "Beph.h"

#define LAUNCH_NETPOS 'lnps'
#define EMAIL_ME 'emlm'
#define FIRST_TIME_USER '1stu'


/* ----- Main ----- */
int main()
{
	prefs_lock = create_sem(1, "Beph Prefs Lock");
	acquire_sem(prefs_lock);
	prefs = new TPreferences("Beph_Prefs");
	if (prefs->InitCheck() != B_OK)
		exit;
	release_sem(prefs_lock);
	
	Beph *myApplication;
	myApplication = new Beph();
	myApplication->Run();
	
	delete myApplication;
	
	acquire_sem(prefs_lock);
	delete prefs;
	delete_sem(prefs_lock);
	
	return 0;
}

/* ---------- CLASS Beph ---------- */

/* ----- Beph::Beph ----- */
Beph::Beph()
	:BApplication("application/x-vnd.Beph")
{
	BRect frameRect;
	
	bool found = true;
	acquire_sem(prefs_lock);
	if(!prefs->HasRect("frame"))
	{
		frameRect.Set(0,0,550,600);
		frameRect.OffsetTo(50,50);
	}
	else
	{
		frameRect = prefs->FindRect("frame");
	}
	
	if(!prefs->HasString("server"))
	{
		default_server = "ns.uiuc.edu";
	}
	else
	{
		default_server = strdup( prefs->FindString("server"));
	}
	
	if(!prefs->HasBool("bla"))
	{
		prefs->SetBool("bla", true);
		found = false;
	}
	else
	{
		found = true;
	}
	release_sem(prefs_lock);
	
	if (!found) PostMessage(FIRST_TIME_USER);

	myWindow = new BephWindow(frameRect, default_server);
	if (myWindow)
	{
		myWindow->Show();
	}
	else
	{
		PostMessage(B_QUIT_REQUESTED);
	}
}

/* ----- Beph::MessageReceived ----- */
void Beph::MessageReceived(BMessage *msg)
{
	switch (msg->what)
	{
		case FIRST_TIME_USER:
		{
			(new BAlert("About",
			"Beph 1.2.2\n\n"
			""B_UTF8_COPYRIGHT" 1997-1999 Vikram Kulkarni\n"
			"All Rights Reserved\n"
			"Portions "B_UTF8_COPYRIGHT" 1991-1999, Be Incorporated.\n"
			"All rights reserved\n\n"
			"Please read the LICENSE file that should have come\n"
			"with your Beph distribution\n\n"
			"Thank you for choosing Beph.  You'll want to pick your ph server from the menu and then save your settings, otherwise you may keep getting this message.\n"
			"\t\t- Vikram Kulkarni\n"
			"\t\t  vkulkarn@uiuc.edu\n",
			 "Okay", NULL, NULL, B_WIDTH_AS_USUAL, B_IDEA_ALERT))->Go();
			
			break;
		}
		
		case LAUNCH_NETPOS:
		{

			status_t	result;
			char *url = (char *) msg->FindString("URL");
			result = be_roster->Launch("text/html", 1, &url);
			if ((result != B_NO_ERROR) && (result != B_ALREADY_RUNNING))
			{
				(new BAlert("", "There is no installed handler for 'text/html'.", "Sorry"))->Go();
			}
			break;
		}
		
		case EMAIL_ME:
		{
			status_t result;
			char * email_addr = (char *)msg->FindString("EmailWho");
			result = be_roster->Launch("text/x-email", 1, &email_addr);
			if ((result != B_NO_ERROR) && (result != B_ALREADY_RUNNING))
			{
				(new BAlert("", "There is no installed handler ofr 'text/x-email'.", "Sorry"))->Go();
			}
			break;
		}
	
		default:
		{
			BApplication::MessageReceived(msg);
			break;
		}
	}
}

/* ----- Beph::AboutRequested ----- */
// Show's the About box...
void Beph::AboutRequested()
{
/* SPANKY ASS ABOUT WINDOW THAT DOESN'T LIKE IT WHEN THE FONTS CHANGE....

		BWindow		*about_window;
		BRect frame(0,0,300,200);
		about_window = new BWindow(frame,  "About Beph 1.2", B_TITLED_WINDOW, B_WILL_ACCEPT_FIRST_CLICK | B_NOT_RESIZABLE | B_NOT_ZOOMABLE);
		BFont font;
		font.SetFamilyAndStyle("Swis721 BT", "Roman");
		font.SetSize(10);
		
		BView *background = new BView(frame, "Background", B_FOLLOW_ALL_SIDES, B_WILL_DRAW);
		background->SetViewColor(219,219,219);
		about_window->AddChild(background);

		frame.left += 10;
		frame.right -= 170;
		frame.top += 5;
		frame.bottom -= 150;
		BRect textframe = frame;
		textframe.OffsetTo(0,0);
		BTextView *text_view = new BTextView(frame, "TextView", textframe, B_FOLLOW_ALL_SIDES, B_WILL_DRAW);
		text_view->SetFont(&font);
		text_view->SetTabWidth(10);
		text_view->SetViewColor(219, 219, 219);
		text_view->MakeEditable(false);
		text_view->MakeSelectable(false);
		text_view->Insert("Beph 1.2\n");
		text_view->Insert("© 1997 Vikram Kulkarni\n");
		text_view->Insert("All Rights Reserved\n\n");
		background->AddChild(text_view);

		frame.right += 160;
		frame.top = frame.bottom + 10;
		frame.bottom += 75;
		textframe = frame;
		textframe.OffsetTo(0,0);
		BTextView *text_view_two = new BTextView(frame, "TextViewTwo", textframe, B_FOLLOW_ALL_SIDES, B_WILL_DRAW);
		text_view_two->SetFont(&font);
		text_view_two->SetTabWidth(10);
		text_view_two->SetViewColor(219, 219, 219);
		text_view_two->MakeEditable(false);
		text_view_two->MakeSelectable(false);
		text_view_two->Insert("Beph is email ware.  Please email me if you use it\n");
		text_view_two->Insert("			-Vik\n\n\n");
		text_view_two->Insert("And try out these web sites while you're online:\n");
		background->AddChild(text_view_two);

		BMessage urlmsg(LAUNCH_NETPOS);
		urlmsg.AddString("URL", "http://www.students.uiuc.edu/~vkulkarn/");
		frame.top = frame.bottom + 2;
		StringControl *my_web_page = new StringControl(frame, "mywebpage", "http://www.uiuc.edu/ph/www/vkulkarn/", new BMessage(&urlmsg), NULL, NULL, &font);
		my_web_page->ResizeToPreferred();
		background->AddChild(my_web_page);
		my_web_page->SetTarget(be_app);

		frame.top = frame.bottom + 16;
		urlmsg.ReplaceString("URL", "http://www.acm.uiuc.edu/bug/");
		StringControl *bug_web_page = new StringControl(frame, "bugwebpage", "http://www.acm.uiuc.edu/bug/", new BMessage(&urlmsg), NULL, NULL, &font);
		bug_web_page->ResizeToPreferred();
		background->AddChild(bug_web_page);
		bug_web_page->SetTarget(be_app);

		frame.top = frame.bottom + 30;
		urlmsg.ReplaceString("URL", "http://www.be.com/");
		StringControl *stool_web_page = new StringControl(frame, "stoolwebpage", "http://www.be.com/", new BMessage(&urlmsg), NULL, NULL, &font);
		stool_web_page->ResizeToPreferred();
		background->AddChild(stool_web_page);
		stool_web_page->SetTarget(be_app);

		frame.Set(123,16, 150,150);
		BMessage emailmsg(EMAIL_ME);
		emailmsg.AddString("EmailWho", "mailto:vkulkarn@uiuc.edu");
		StringControl *email= new StringControl(frame, "email", "(vkulkarn@uiuc.edu)", new BMessage(&emailmsg), NULL, NULL, &font);
		email->ResizeToPreferred();
		background->AddChild(email);
		email->SetTarget(be_app);

		BFont big_font(font);
		big_font.SetSize(18);
		frame = background->Bounds();
		StringControl *quit_button = new StringControl(frame, "quit_button", "Okay", new BMessage(B_QUIT_REQUESTED), NULL, NULL, &big_font);
		float width = 0.0, height = 0.0;
		quit_button->GetPreferredSize(&width, &height);
		quit_button->MoveTo(frame.Width() - width - 5, frame.Height() - height - 5);
		quit_button->ResizeToPreferred();
		background->AddChild(quit_button);
		

		about_window->MoveTo(100,100);
		about_window->Show();
*/
	BAlert *about = new BAlert("About",
	"Beph 1.2.2\n\n"
	""B_UTF8_COPYRIGHT" 1997-1999 Vikram Kulkarni\n"
	"All Rights Reserved\n"
	"Portions "B_UTF8_COPYRIGHT" 1991-1999, Be Incorporated.\n"
	"All rights reserved\n\n"
	"Please read the LICENSE file that should have come\n"
	"with your Beph distribution\n",

	 "Okay");
	
	about->Go(NULL);
}

bool Beph::QuitRequested()
{
	return true;
}
