// Beph 1.1
// Vikram Kulkarni
// BephView.cpp

#define BEPH_SAVE_SETTINGS 'phst'
#define BUTTON 'bttn'
#define CHECK_BOX 'chbx'
#define INPUT 'inpt'
#define SERVER 'srvr'
#define SERVER_LIST_MENU 'srmn'
#define SHOW_HIDE 'shhd'
#define TEST 'test'

#include "BephViews.h"


/* ---------- CLASS BephMenuView ---------- */
/* ----- BephMenuView::BephMenuView ----- */
BephMenuView::BephMenuView(BRect frame)
	:BMenuBar(frame, "BephMenuBar")
{
	BMenu *Menu;
	BMenuItem *menuItem;
	
	AddItem(Menu = new BMenu("File"));
	
	Menu->AddItem(menuItem = new BMenuItem("About Beph"B_UTF8_ELLIPSIS, new BMessage(B_ABOUT_REQUESTED)));
	menuItem->SetTarget(be_app);
	
	Menu->AddSeparatorItem();
	
	Menu->AddItem(menuItem = new BMenuItem("Save Current Server", new BMessage(BEPH_SAVE_SETTINGS)));
	menuItem->SetTarget(Window());

	Menu->AddSeparatorItem();
	
	Menu->AddItem(menuItem = new BMenuItem("Quit", new BMessage(B_QUIT_REQUESTED), 'Q'));
	//menuItem->SetTarget(be_app);
	
	ResizeToPreferred();
}

/* ---------- CLASS BephQueryView ---------- */
/* ----- BephQueryView::BephQueryView ----- */
BephQueryView::BephQueryView(BRect frame, char *server)
	:BBox(frame , "BephQueryView", B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE_JUMP, B_FANCY_BORDER)
{
	SetViewColor(219,219,219);
	
	font_height temp_height;
	be_plain_font->GetHeight(&temp_height);
	float plain_font_height = temp_height.descent + temp_height.ascent;

	BRect inputRect = Bounds();
	inputRect.left = inputRect.left + 3;
	inputRect.right = inputRect.right - be_plain_font->StringWidth("Return All") - 32;
	inputRect.top = inputRect.top + 4;
	inputRect.bottom = inputRect.top + plain_font_height + 3;
	inputView = new BTextControl(inputRect, "InputView", NULL, NULL, new BMessage(INPUT), B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	
	BRect checkRect = Bounds();
	checkRect.left = inputRect.right + 3;
	checkRect.right = checkRect.right - 5;
	checkRect.top = inputRect.top;
	checkRect.bottom = inputRect.bottom;
	checkBox = new BCheckBox(checkRect, "CheckBox", "Return All", new BMessage(CHECK_BOX), B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
		
	BRect serverRect = Bounds();
	serverRect.left = serverRect.left + 20;
	serverRect.right = (serverRect.right/3) - 5;
	serverRect.top = inputRect.bottom + plain_font_height + 5.5;
	serverRect.bottom = serverRect.top + plain_font_height + 3;
	serverView = new BTextControl(serverRect, "ServerView", "ph Server", server, new BMessage(SERVER), B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	serverView->SetDivider(be_plain_font->StringWidth("ph Server "));
	
	BRect serverListRect = Bounds();
	serverListRect.left = serverRect.right + 10;
	serverListRect.right = 3 * (serverListRect.right/4);
	serverListRect.top = serverRect.top - 2;
	serverListRect.bottom = serverRect.bottom;
	BPopUpMenu *serverMenu = BuildServerMenu(server);
	serverList = new BMenuField(serverListRect, "ServerList", NULL, serverMenu, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW);
	serverMenu->SetTargetForItems(Window());
	
	BRect buttonRect = Bounds();
	buttonRect.left = serverListRect.right + 10;
	buttonRect.right =  buttonRect.right - 8;
	buttonRect.top = serverRect.top - 5.5;
	buttonRect.bottom = serverRect.bottom;
	button = new BButton(buttonRect, "Button", "Submit", new BMessage(BUTTON), B_FOLLOW_TOP, B_WILL_DRAW);
	buttonRect = button->Bounds();
	
	rgb_color tri_col, black;
	tri_col = ui_color(B_KEYBOARD_NAVIGATION_COLOR);
	tint_color(tri_col, 0.1);
//	tri_col.red = 102;
//	tri_col.green = 203;
//	tri_col.blue = 255;
	black.red = black.green = black.blue = 0;
	BBitmap *temp_bitmap = new BBitmap(BRect(0,0,9,9), B_RGB_32_BIT, true);
	BView *temp_view = new BView(BRect(0,0,9,9), "TempView", B_FOLLOW_ALL_SIDES, B_WILL_DRAW);
	temp_bitmap->Lock();
	temp_bitmap->AddChild(temp_view);
	temp_view->SetViewColor(219,219,219);
	temp_view->BeginPicture(new BPicture());
	temp_view->SetHighColor(219,219,219);
	temp_view->FillRect(BRect(0,0,9,9));
	temp_view->SetHighColor(tri_col);
	temp_view->FillTriangle(BPoint(3,1), BPoint(3,9), BPoint(7,5));
	temp_view->SetHighColor(black);
	temp_view->StrokeTriangle(BPoint(3,1), BPoint(3,9), BPoint(7,5));
	BPicture *up_pict = temp_view->EndPicture();
	temp_view->SetHighColor(219,219,219);
	temp_view->BeginPicture(new BPicture());
	temp_view->FillRect(BRect(0,0,9,9));
	temp_view->SetHighColor(tri_col);
	temp_view->FillTriangle(BPoint(1,3), BPoint(9,3), BPoint(5,7));
	temp_view->SetHighColor(black);
	temp_view->StrokeTriangle(BPoint(1,3), BPoint(9,3), BPoint(5,7));
	BPicture *down_pict = temp_view->EndPicture();
	temp_bitmap->Unlock();
	delete temp_bitmap;

	BRect show_hideRect;
	show_hideRect.left = inputRect.left + 3;
	show_hideRect.right = show_hideRect.left + 11;
	show_hideRect.top = serverRect.top + plain_font_height/2;
	show_hideRect.bottom = show_hideRect.top + 11;
	show_hide_button = new BPictureButton(show_hideRect, "ShowHideButton", down_pict, up_pict, new BMessage(SHOW_HIDE), B_TWO_STATE_BUTTON,B_FOLLOW_LEFT, B_WILL_DRAW);

	AddChild(inputView);
	AddChild(checkBox);
	AddChild(serverView);
	AddChild(serverList);
	AddChild(button);
	AddChild(show_hide_button);
	
	ResizeTo(frame.Width(), button->Frame().bottom + 10);
	
	inputView->SetTarget(Window());
	(inputView->TextView())->SetMaxBytes(97);
	checkBox->SetTarget(Window());
	serverView->SetTarget(Window());
	button->SetTarget(Window());
	show_hide_button->SetTarget(Window());
}

BephQueryView::~BephQueryView()
{
}


BPopUpMenu *BephQueryView::BuildServerMenu(char *server)
{
	BPopUpMenu *Menu = new BPopUpMenu("ph Servers");
	BMenuItem *menuItem;
	for (int count = 0; count < NUMBER_OF_SERVERS_IN_LIST; count++)
	{
		menuItem = new BMenuItem(servers_type[2*count], new BMessage(SERVER_LIST_MENU));
		Menu->AddItem(menuItem);
		if (!strcmp(server, servers_type[2*count + 1])) menuItem->SetMarked(true);
	}
	
	return Menu;
}

/* ---------- CLASS BephOutputView ---------- */
/* ----- BephOutputView::BephOutputView ----- */
BephOutputView::BephOutputView(BRect frame)
	:BView(frame, "BephOutputView", B_FOLLOW_ALL_SIDES, B_WILL_DRAW | B_DRAW_ON_CHILDREN)
{
	SetViewColor(219,219,219);
	
	BRect outputRect;
	outputRect = Bounds();
	outputRect.right -= B_V_SCROLL_BAR_WIDTH;
	outputRect.bottom = outputRect.bottom - B_H_SCROLL_BAR_HEIGHT;
	BRect outputTextRect;
	outputTextRect = outputRect;
	outputTextRect.OffsetTo(0,0);
	outputTextRect.InsetBy(2,2);
	outputTextRect.right = 100 * be_fixed_font->StringWidth(" ");
	outputTextView = new BTextView(outputRect, "OutputView", outputTextRect, B_FOLLOW_ALL_SIDES, B_WILL_DRAW);
	
	scrollView = new BScrollView("ScrollView", outputTextView, B_FOLLOW_ALL_SIDES, B_WILL_DRAW, true, true, B_PLAIN_BORDER);
	BScrollBar *scrollbar;
	BRect scrollRect;
	scrollbar = scrollView->ScrollBar(B_HORIZONTAL);
	scrollRect = scrollbar->Frame();
	scrollRect.left = frame.Width()/2;
	scrollbar->ResizeTo(scrollRect.Width(), scrollRect.Height());
	scrollbar->MoveTo(scrollRect.LeftTop());
	
	BRect rect;
	rect.left = 0;
	rect.right = scrollRect.left - 1.0;
	rect.top = scrollRect.top - 1.0;
	rect.bottom = Bounds().bottom;
	status_border = new BBox(rect, "StatusBorder", B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW, B_NO_BORDER);
	status_border->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	rgb_color bla = status_border->ViewColor();

	rect = status_border->Bounds();
	rect.left += 5;
	rect.right = rect.right - (rect.Width()/3) - 5;
	rect.top += 1;
	rect.bottom -= 1;
	statusView = new BStringView(rect, "StatusView", "idle...", B_FOLLOW_LEFT_RIGHT | B_FOLLOW_BOTTOM, B_WILL_DRAW);
	status_border->AddChild(statusView);
	statusView->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	
	rgb_color stat_bar_color = ui_color(B_KEYBOARD_NAVIGATION_COLOR);
	tint_color(stat_bar_color, 0.1);
	rect.left = rect.right + 1.0;
	rect.right = status_border->Bounds().right - 1.0;
	statusBar = new VStatusBar(rect, "StatusBar", B_FOLLOW_RIGHT | B_FOLLOW_BOTTOM);
	statusBar->SetBarHeight(rect.Height() - 4);
	statusBar->SetBarColor(stat_bar_color);
	statusBar->SetMaxValue(1);
	status_border->AddChild(statusBar);
	statusBar->Update(1);
	
	outputTextView->SetWordWrap(false);
	outputTextView->MakeEditable(false);
	outputTextView->SetFontAndColor(be_fixed_font, B_FONT_FAMILY_AND_STYLE);
	
	AddChild(scrollView);
	AddChild(status_border);
}

void BephOutputView::AttachedToWindow()
{
	status_border->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	statusView->SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
}
