// Beph 1.1
// Vikram Kulkarni
// BephWindow.cpp

#define BEPH_SAVE_SETTINGS 'phst'
#define BUTTON 'bttn'
#define CHECK_BOX 'chbx'
#define CONNECT 'cnct'
#define CONNECT_FAILED 'cnfl'
#define CONNECTED_TO_SERVER 'conn'
#define HOW_MANY_MATCHES 'hmny'
#define INPUT 'inpt'
#define SERVER 'srvr'
#define SERVER_REPLY 'srpl'
#define NEXT_MATCH 'nxtm'
#define NO_MATCH 'nomc'
#define NO_NAME_SERVER 'nnsr'
#define QUERY 'qery'
#define QUERY_DONE 'done'
#define SERVER_LIST_MENU 'srmn'
#define SHOW_HIDE 'shhd'
#define TEST 'test'

#include "BephWindow.h"

extern sem_id		prefs_lock;
extern TPreferences	*prefs;

const int NUMBER_OF_SERVERS_IN_LIST = 291;
char *servers_type[] = {
"Albert Einstein College of Medicine",
"ns.aecom.yu.edu",

"Algonquin C. of App. Arts and Tech., Ontario, Canada",
"algnet.algonquinc.on.ca",

"American University, Washington DC",
"ph.american.edu",

"Aston University, United Kingdom",
"gopher.aston.ac.uk",

"Australian Defence Force Academy",
"ns.adfa.oz.au",

"Australian National University",
"cis.anu.edu.au",

"Bar-Ilan University, Israel (Experimental, Hebrew)",
"vm.biu.ac.il",

"Bates College",
"whois.bates.edu",

"Baylor College of Medicine",
"ns.bcm.tmc.edu",

"Beth Israel Hospital (Harvard Univ.)",
"ns.bih.harvard.edu",

"Bilkent University",
"ns.bilkent.edu.tr",

"Board of Governors Universities, IL USA",
"ns.bgu.edu",

"Boston University",
"ns.bu.edu",

"Bowling Green State University",
"ph.bgsu.edu",

"Bradley University",
"ns.bradley.edu",

"Brigham Young University",
"kolob.byu.edu",

"Brookhaven National Laboratory",
"ns.bnl.gov",

"Brown University",
"ns.brown.edu",

"Bucknell University",
"ns.bucknell.edu",

"Cal Poly, San Luis Obispo",
"ns.calpoly.edu",

"Calvin College",
"calvin.edu",

"Camosun College, Victoria, B.C. Canada",
"cso.camosun.bc.ca",

"Canisius College Faculty/Staff",
"gort.canisius.edu",

"Carleton University, Ontario, Canada",
"ernest.carleton.ca",

"Carnegie Inst. of Washington, Dept. of Ter. Mag.",
"dtm.ciw.edu",

"Carnegie Inst. of Washington Geophysical Lab",
"granite.ciw.edu",

"Centre de Ressources Informatiques de Haute-Normandie",
"ns.crihan.fr",

"Cerritos College",
"ns.cerritos.edu",

"Chicago State University, IL USA",
"ns.csu.bgu.edu",

"Chinese University of Hong Kong",
"ns.cuhk.hk",

"CHUUG/EUnet, Switzerland",
"chsun.eunet.ch",

"Claude Bernard University, Lyon, France",
"ns.univ-lyon1.fr",

"Clemson University",
"gopher.clemson.edu",

"Cleveland State University",
"ns.csuohio.edu",

"Cliometric Society",
"clionet.cas.muohio.edu",

"Colby College",
"gopher.colby.edu",

"Columbia University",
"ns.columbia.edu",

"Concordia University, Montreal, Quebec, Canada",
"phone.concordia.ca",

"Cornell College, Iowa",
"ns.cornell-iowa.edu",

"Cornell Directory of Legal Academia",
"ns.law.cornell.edu",

"Cornell University",
"qi.cornell.edu",

"Cornell University Medical College",
"qi.med.cornell.edu",

"Cracow University of Technology, Poland",
"pk-siec.oeto.pk.edu.pl",

"CRS4 - Ctr for Adv Studies, Rsrch, and Dev, Italy",
"ns.crs4.it",

"Curtin Univ. of Technology, Perth, Australia",
"info.curtin.edu.au",

"Dalhousie University, Halifax, Nova Scotia, Canada",
"snoopy.ucis.dal.ca",

"Dana-Farber Cancer Institute",
"ns.dfci.harvard.edu",

"Danville Area Community College, Danville, Illinois",
"ns.dacc.cc.il.us",

"Dartmouth College",
"dnd.dartmouth.edu",

"Deakin University",
"deakin.edu.au",

"Delft University of Technology, Netherlands",
"gopher.tudelft.nl",

"Drake University",
"ns.drake.edu",

"Duke University",
"phonebk.duke.edu",

"Eastern Illinois University, IL USA",
"ns.eiu.bgu.edu",

"Eastern Kentucky University",
"acs.eku.edu",

"Ecole Centrale Paris, France",
"ph.ecp.fr",

"Ecole des Hautes Etudes Commerciales, Montreal, Canada",
"ph.hec.ca",

"Ecole Polytechnique Federale de Lausanne, Switzerland",
"gopher.epfl.ch",

"Educational Computing Network, IL USA",
"ns.ecn.bgu.edu",

"Eidg. Technische Hochschule, Zurich",
"ural.ethz.ch",

"Embry-Riddle Aeronautical University, WEST",
"cso.pr.erau.edu",

"Emory University",
"dooley.cc.emory.edu",

"Energy Sciences Network",
"ph.es.net",

"ENSSIB, Lyon, France",
"ns.univ-lyon1.fr",

"Environmental Protection Agency (EPA)",
"earth1.epa.gov",

"Eurecom Institute, Sophia-Antipolis, France",
"eurecom.cica.fr",

"Fairfield University",
"funrsc.fairfield.edu",

"Fanshawe College, London, Ontario, Canada",
"admin.fanshawec.on.ca",

"Florida Institute of Technology Faculty/Staff",
"sci-ed.fit.edu",

"Florida State University",
"mailer.fsu.edu",

"Geodetic Survey of Canada",
"ns.geod.emr.ca",

"Georgia Institute of Technology",
"lu-serve.gatech.edu",

"Georgia Southern University",
"ns.gasou.edu",

"Glassboro State University",
"gboro.glassboro.edu",

"Global Cycling Network",
"cycling.org",

"Government of New Brunswick, Canada",
"picture.gov.nb.ca",

"Governors State University, IL USA",
"ns.gsu.bgu.edu",

"Groningen University, Arts/Theol/Phil, Netherlands",
"ns.let.rug.nl",

"Gustavus Adolphus College",
"ns.gac.edu",

"Hamline University",
"piper.hamline.edu",

"Harvard University",
"scunix1.harvard.edu",

"Helsinki University of Technology",
"ns.cs.hut.fi",

"Humber College of Applied Arts and Technology, Canada",
"admin.humberc.on.ca",

"Illinois Math and Science Academy",
"ns.imsa.edu",

"Indiana University-Purdue Univ. at Indianapolis",
"hyrax.iupui.edu",

"Indiana University of Pennsylvania",
"ns.iup.edu",

"INSA-Lyon, France",
"ns.univ-lyon1.fr",

"Intl. Ctr. for Genetic Eng. & Biotech., Italy",
"genes.icgeb.trieste.it",

"Iowa State University of Science and Technology",
"isuad1.iastate.edu",

"Israel-wide Univ/Corp Email Searches (Experimental)",
"vm.tau.ac.il",

"Johns Hopkins University",
"rad.hcf.jhu.edu",

"Katholieke Universiteit Leuven, Belgium",
"ns.kuleuven.ac.be",

"Keio University, Sci. & Tech. Campus, Japan",
"bash.cc.keio.ac.jp",

"Kennesaw State College",
"gopher.kennesaw.edu",

"Kent State University",
"phoenix.kent.edu",

"Kutztown University",
"kutztown.edu",

"Lakehead University",
"flash.lakeheadu.ca",

"Lambton College, Canada",
"ns.lambton.on.ca",

"Lawrence Livermore National Laboratory",
"ns.llnl.gov",

"Lehigh University",
"ns.lehigh.edu",

"Lewis University",
"cs.lewisu.edu",

"Library of Congress",
"marvel.loc.gov",

"Linkoping University, Sweden",
"ns.liu.se",

"Los Alamos National Laboratory",
"lanl.gov",

"Loughborough University of Technology, United Kingdom",
"dir.lut.ac.uk",

"Loyola University, Chicago",
"ns.luc.edu",

"Magnavox Electronic Systems Company",
"gw1.magec.com",

"Mahidol University, Thailand, Staff",
"ns.mahidol.ac.th",

"Massachusetts Institute of Technology",
"mitdir.mit.edu",

"Massey University, New Zealand",
"ns.massey.ac.nz",

"McGill Univ. Research Centre for Intelligent Machines",
"lightning.mcrcim.mcgill.edu",

"McMaster University, Canada, Faculty/Staff",
"mcmail.cis.mcmaster.ca",

"Medical University of South Carolina, Faculty/Staff",
"qi.musc.edu",

"Memorial Sloan-Kettering Cancer Center",
"bigmac.mskcc.org",

"Miami University (Ohio, USA)",
"ph.muohio.edu",

"Michigan State University Faculty/Staff",
"cso.msu.edu",

"Michigan State University Students",
"pilot0.cl.msu.edu",

"Michigan Technological University",
"mtu-ns.mtu.edu",

"Middle East Technical University (METU), Turkey",
"mogan.cc.metu.edu.tr",

"Mount Saint Mary's College",
"msmary.edu",

"Muhlenberg College",
"rocky.muhlberg.edu",

"NASA Lewis Research Center",
"aruba.lerc.nasa.gov",

"National Autonomous University of Mexico (UNAM)",
"condor.dgsca.unam.mx",

"National Institute of Standards and Technology",
"cso.nist.gov",

"National Institutes of Health",
"ph.nih.gov",

"National Oceanic and Atmospheric Admin., Boulder",
"cso.erl.noaa.gov",

"National Renewable Energy Laboratory",
"ns.nrel.gov",

"National Science Foundation",
"phsrvr.nsf.gov",

"National University of Singapore",
"nuscc.nus.sg",

"New York University",
"ph.nyu.edu",

"New York University Medical Center",
"popmail.med.nyu.edu",

"Nijenrode University, Netherlands",
"gopher.nijenrode.nl",

"North Carolina Cooperative Extension Service, NCSU",
"twosocks.ces.ncsu.edu",

"North Dakota State University",
"plains.nodak.edu",

"Northeastern Illinois University, IL USA",
"ns.neiu.bgu.edu",

"Northeast Missouri State University",
"noc.nemostate.edu",

"Northwestern University",
"ns.nwu.edu",

"Oak Ridge National Laboratory",
"ns.esd.ornl.gov",

"Occidental College",
"chesire.oxy.edu",

"ODTU Cevrimici Telefon Rehberi, Turkey",
"knidos.cc.metu.edu.tr",

"Ohio Northern University",
"ns.onu.edu",

"Old Dominion University Faculty/Staff",
"gopher.odu.edu",

"OpenConnect Systems",
"ph.oc.com",

"Oregon Research Institute",
"aragorn.ori.org",

"Oregon State University",
"ph.orst.edu",

"Penn State University",
"ph.psu.edu",

"Plymouth State College, New Hampshire",
"eeyore.plymouth.edu",

"Portland State University",
"skade.cc.pdx.edu",

"Portland State Univ., Schl of Eng and Applied Sciences",
"ph.ee.pdx.edu",

"Princeton University",
"princeton.edu",

"Public Health Research Institute",
"ph.phri.nyu.edu",

"Purdue University",
"directory.purdue.edu",

"Quebecor Inc.",
"ph.quebecor.com",

"Queen Mary and Westfield College, London, UK",
"beta.qmw.ac.uk",

"Queen's University, Kingston, Canada",
"info.queensu.ca",

"Queensland Institute of Medical Research, Australia",
"panther.qimr.edu.au",

"Rsch. Inst. for Sym. Comp. (RISC-Linz), Austria",
"info.risc.uni-linz.ac.at",

"Rice University",
"cwis.rice.edu",

"Rider University",
"genius.rider.edu",

"Rose-Hulman Institute of Technology",
"ns.rose-hulman.edu",

"Roskilde Universitetscenter, Denmark",
"ns.ruc.dk",

"Ryerson Polytechnic University",
"ph.acs.ryerson.ca",

"Saint Michael's College, Colchester VT",
"smcvax.smcvt.edu",

"Saint Norbert College",
"ph.snc.edu",

"Sam Houston State University",
"niord.shsu.edu",

"Sir Sandford Fleming College, Canada",
"gopher.flemingc.on.ca",

"St. Olaf College",
"cso.stolaf.edu",

"State University of New York at Buffalo",
"lictor.acsu.buffalo.edu",

"State University of New York at Geneseo",
"newt.cc.geneseo.edu",

"State University of New York at Oswego",
"cso.oswego.edu",

"State University of New York, Potsdam College",
"gopher.dc.potsdam.edu",

"SUNY Computer Officers Association",
"gram.cc.geneseo.edu",

"SUNY System (Central) Administration",
"cso.sunycentral.edu",

"Swarthmore College",
"ph.cc.swarthmore.edu",

"Syracuse University",
"dataserver.syr.edu",

"Technical Research Centre, Finland",
"ns.vtt.fi",

"Technical University of Eindhoven, Netherlands",
"mailhost.tue.nl",

"Technical University of Nova Scotia, Canada",
"newton.ccs.tuns.ca",

"Texas A&M University",
"ns.tamu.edu",

"Texas Tech University",
"unicorn.acs.ttu.edu",

"Trent University, Peterborough, Ont., Canada",
"blaze.trentu.ca",

"Trinity College, Hartford, CT",
"ns.trincoll.edu",

"UFSIA, University of Antwerp, Belgium",
"ns.ufsia.ac.be",

"United Medical & Dental Schools, London, UK",
"ph.umds.ac.uk",

"Universidad de Los Andes, Bogota, Colombia",
"ph.uniandes.edu.co",

"Universidad del Valle, Cali, Colombia",
"mafalda.univalle.edu.co",

"Universitaire Instelling Antwerpen, Belgium",
"cso.uia.ua.ac.be",

"Universite Catholique de Louvain",
"annuaire.sia.ucl.ac.be",

"Universite de Valenciennes, France",
"ns.univ-valenciennes.fr",

"University of Alberta, Canada",
"chinchaga.ucs.ualberta.ca",

"University of Arizona",
"ns.arizona.edu",

"University of British Columbia, Canada",
"phserver.ubc.ca",

"University of California at Berkeley",
"infocal.berkeley.edu",

"University of California at Davis",
"geology.ucdavis.edu",

"University of California at Irvine",
"qi.service.uci.edu",

"University of California at Los Angeles",
"directory.ucla.edu",

"University of California at San Diego",
"ucsd.edu",

"University of California at San Francisco",
"itsa.ucsf.edu",

"University of California at Santa Barbara",
"ucsbuxa.ucsb.edu",

"University of California Systemwide Administration",
"directory.ucop.edu",

"University of Cape Town, South Africa",
"gopher.cs.uct.ac.za",

"University of Central Florida",
"pegasus.cc.ucf.edu",

"University of Chicago",
"prism.uchicago.edu",

"University of Cincinnati",
"ucunix.san.uc.edu",

"University of Colorado, Boulder",
"directory.colorado.edu",

"University of Colorado, Colorado Springs, Faculty/Staff",
"ns.uccs.edu",

"University of Florida",
"ns.ufl.edu",

"University of Georgia",
"phonebook.uga.edu",

"University of Guelph, Canada",
"nermal.cs.uoguelph.ca",

"University of Hamburg, Germany",
"playmate.uni-hamburg.de",

"University of Hamburg, Dept. Econ & Bus. Admin.",
"ns.econ.uni-hamburg.de",

"University of Hawaii",
"ns.hawaii.edu",

"University of Idaho Faculty/Staff",
"owl.csrv.uidaho.edu",

"University of Illinois at Chicago",
"ns.uic.edu",

"University of Illinois at Urbana-Champaign",
"ns.uiuc.edu",

"University of Iowa",
"ns.uiowa.edu",

"University of Kansas School of Engineering",
"ns.tisl.ukans.edu",

"University of Kentucky",
"ukcc.uky.edu",

"Universite Laval, Genie Electrique",
"cso.gel.ulaval.ca",

"Universite Laval, Quebec, Canada",
"ns.ulaval.ca",

"University of Liege, Belgium",
"ph.ulg.ac.be",

"University of Maine Faculty/Staff",
"goofy.umecit.maine.edu",

"University of Manchester and UMIST, UK",
"info.mcc.ac.uk",

"University of Maryland at Baltimore",
"umabnet.ab.umd.edu",

"University of Maryland, Baltimore County",
"cso.umbc.edu",

"University of Massachusetts at Amherst",
"ns.umass.edu",

"University of Memphis",
"ns.memst.edu",

"University of Minnesota",
"ns.umn.edu",

"University of Missouri - Rolla Faculty/Staff",
"cso-employee-phonebook.cc.umr.edu",

"University of Montana",
"selway.umt.edu",

"University of Munich, Germany",
"ns.informatik.uni-muenchen.de",

"University of Nebraska at Lincoln",
"unlmail.unl.edu",

"University of Nebraska at Omaha",
"ns.unomaha.edu",

"University of New Brunswick, Canada",
"ns.unb.ca",

"University of New England, Northern Rivers, Australia",
"elli.une.edu.au",

"University of North Texas",
"gopher.unt.edu",

"University of Notre Dame",
"ns.nd.edu",

"University of Oklahoma",
"ns.uoknor.edu",

"University of Oregon",
"whois.uoregon.edu",

"University of Oslo, Norway",
"ph.uio.no",

"University of Otago, Dunedin, New Zealand",
"ns.otago.ac.nz",

"University of Pennsylvania",
"ph-server.upenn.edu",

"University of Pretoria, South Africa",
"qi.up.ac.za",

"University of Rhode Island",
"phonebk.uri.edu",

"University of Salzburg, Austria",
"dsb835.edvz.sbg.ac.at",

"University of South Africa (Unisa)",
"gopher.unisa.ac.za",

"University of South Carolina",
"bigbird.csd.scarolina.edu",

"University of South Florida",
"dotrisc.cfr.usf.edu",

"University of Southern California",
"cwis.usc.edu",

"University of Southern Maine Faculty/Staff",
"csir1.usmacs.maine.edu",

"University of Southhampton, UK, Dept of Mathematics",
"mir.maths.soton.ac.uk",

"University of Sydney, Australia",
"phone.su.edu.au",

"University of Sydney, Faculty of Law, Australia",
"sulaw.law.su.oz.au",

"University of Tasmania, Australia",
"info.utas.edu.au",

"University of Tennessee at Chattanooga",
"cecasun.utc.edu",

"University of Tennessee at Knoxville",
"ns.utcc.utk.edu",

"University of Texas at Austin",
"mojo.ots.utexas.edu",

"University of Texas CHPC",
"hermes.chpc.utexas.edu",

"University of Texas Medical Branch",
"bluefin.utmb.edu",

"University of Trento, Italy",
"mambo.cs.unitn.it",

"University of Tulsa",
"ns.utulsa.edu",

"University of Utah",
"ph.cc.utah.edu",

"University of Utrecht, Netherlands",
"nic.cc.ruu.nl",

"University of Vermont",
"ns.uvm.edu",

"University of Victoria, Canada",
"netinfo.uvic.ca",

"University of Waterloo, Ontario, Canada",
"uwdir.uwaterloo.ca",

"University of West Bohemia, Czech Republic",
"ph.zcu.cz",

"University of Winnepeg, Canada",
"uwpg02.uwinnipeg.ca",

"University of Wisconsin - Eau Claire",
"gopher.uwec.edu",

"University of Wisconsin at Madison",
"wisc.edu",

"University of Wisconsin at Milwaukee",
"risc1.os.uwm.edu",

"University of Wisconsin - Platteville",
"shamu.oit.uwplatt.edu",

"Universite du Quebec a Montreal, Quebec, Canada",
"cso.uqam.ca",

"Uppsala University, Sweden",
"ns.uu.se",

"US Army Corps of Engineers, C.E.R. Lab",
"ns.cecer.army.mil",

"U.S. Department of Education",
"gopher.ed.gov",

"US Geological Survey",
"ridgisd.er.usgs.gov",

"Utah State University Extension Service",
"extsparc.agsci.usu.edu",

"Vanderbilt University",
"ph.vanderbilt.edu",

"Virginia Polytechnic Institute and State Univ.",
"ns.vt.edu",

"Vrije Universiteit Amsterdam",
"csohost.cca.vu.nl",

"Wake Forest University",
"cso.wfu.edu",

"Washington State Univ., Pullman",
"serval.net.wsu.edu",

"Washington University, St. Louis",
"ns.wustl.edu",

"Weizmann Institute of Science, Israel",
"wisslc1.weizmann.ac.il",

"Western Illinois University, IL USA",
"ns.wiu.bgu.edu",

"Wheaton College",
"david.wheaton.edu",

"Williams College",
"ns.williams.edu",

"Wilmington College",
"ns.wilmington.edu",

"Yale University",
"directory.yale.edu",

"York University, Canada",
"ph.yorku.ca"
};


/* ---------- CLASS BephWindow ---------- */
/* ----- BephWindow::BephWindow ----- */
BephWindow::BephWindow(BRect frame, char *Server)
	:BWindow(frame, "Beph 1.2.2", B_DOCUMENT_WINDOW, B_NOT_H_RESIZABLE, B_CURRENT_WORKSPACE)
{
	server = Server;
	request_active = false;
	alias_equals = false;
	return_all = false;
	output_view_shown = true;
	old_size = frame;
	lines = 0;

	BRect menuRect;
	menuRect = Bounds();
	menuRect.bottom = menuRect.top + 18;
	menuView = new BephMenuView(menuRect);
	AddChild(menuView);
	menuRect = menuView->Frame();
	
	BRect queryRect;
	queryRect = Bounds();
	queryRect.top = menuRect.bottom;
	queryRect.bottom = queryRect.top + 60;
	queryRect.left = queryRect.left - 1;
	queryRect.right = queryRect.right + 2;
	queryView = new BephQueryView(queryRect, server);
	AddChild(queryView);
	SetDefaultButton(queryView->button);
	queryRect = queryView->Frame();
	
	BRect outputRect;
	outputRect = Bounds();
	outputRect.top = queryRect.bottom;
	outputView = new BephOutputView(outputRect);
	AddChild(outputView);

	min_height = menuRect.Height() + queryRect.Height();
	scroll_bar_info info;
	get_scroll_bar_info( &info );
	min_height += (2 * info.min_knob_size); // we want them to be able to use the knob...
	min_height += 2 * 16.0; // each arrow is 15 or 16 pixle's heigh...
	
	BScreen screen(this);
	max_height = screen.Frame().Height() + 1;
	
	SetSizeLimits(frame.Width(),frame.Width(), min_height ,max_height);
	
	// this line dedicated to Jason Luther
	(queryView->inputView)->MakeFocus();
	// end dedication
	
	parser = new BephParser(this);
	
	netReq = new BephNet(server, this, parser);
	netReq->PostMessage(CONNECT);
}

/* ----- BephWindow::~BephWindow ----- */
BephWindow::~BephWindow()
{
	netReq->PostMessage(B_QUIT_REQUESTED);
}

/* ----- BephWindow::QuitRequested ----- */
bool BephWindow::QuitRequested()
{
	BRect frame;
	if (!output_view_shown)
	{
		frame = old_size;
		frame.OffsetTo((Frame()).LeftTop());
	}
	else
		frame = Frame();
	
	//SAVE FRAME SIZE SETTINGS HERE!!!
	acquire_sem(prefs_lock);
	prefs->SetRect("frame", frame);
	release_sem(prefs_lock);

	be_app->PostMessage(B_QUIT_REQUESTED);
	return (true);
}

/* ----- BephWindow::MessageReceived ----- */
void BephWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case INPUT:
			{
				break;
			}
		case BUTTON:
			{
				if (!request_active)
				{
					alias_equals = false;
					char *command = (char *)(queryView->inputView)->Text();
					
					if (*command == '\0')
					{
						BAlert *myAlert;
						myAlert = new BAlert("Woops", "Nothing to submit...", "Woops...");
						myAlert->Go(NULL);
					}
					else
					{
						BMessage *phmsg = new BMessage(QUERY);
						phmsg->AddString("PH_COMMAND", command );
						phmsg->AddBool("RETURN_ALL_STATE", return_all);
						phmsg->AddBool("ALIAS_EQUALS", alias_equals);
						
						Lock();
						(outputView->outputTextView)->SetText("");
						Unlock();
						
						netReq->PostMessage(phmsg);
						delete (phmsg);
	
						request_active = true;
						Lock();
						(outputView->statusView)->SetText("waiting for reply...");
						Unlock();
						lines = 0;
					}
				}
				else
				{
					BAlert *myAlert;
					myAlert = new BAlert("Sorry...","Can't do more than one query at a time.","Okay...");
					myAlert->Go(NULL);
				}
				
				break;
			}
			
		case CHECK_BOX:
			{
					return_all = !return_all;
					break;
			}
			
		case SERVER:
			{
				netReq->PostMessage(B_QUIT_REQUESTED);
				
				server = (char *)(queryView->serverView)->Text();
				
				SetLocation_Name(server);
				
				Lock();
				(outputView->statusView)->SetText("connecting to new server...");
				Unlock();
				
				netReq = new BephNet(server, this, parser);
				netReq->PostMessage(CONNECT);
				
				break;
			}

		case BEPH_SAVE_SETTINGS:
			{
				const char * new_server = (queryView->serverView)->Text();

				acquire_sem(prefs_lock);
				prefs->SetString("server", new_server);
				release_sem(prefs_lock);

				break;
			}
			
		case SERVER_LIST_MENU:
			{
				BMenuItem *selected_server = (queryView->serverList->Menu())->FindMarked();
				const char *Location_Name = selected_server->Label();
				
				
				char *temp = FindServer(Location_Name);
				
				if (temp != NULL)
				{
					netReq->PostMessage(B_QUIT_REQUESTED);
					server = temp;

					Lock();
					(outputView->statusView)->SetText("connecting to new server...");
					(queryView->serverView)->SetText(server);
					Unlock();

					netReq = new BephNet(server, this, parser);
					netReq->PostMessage(CONNECT);
				}
				
				break;
			}
			
		case SERVER_REPLY:
			{
				if (!lines)
				{
					Lock();
					(outputView->statusView)->SetText("receiving reply...");
					Unlock();
				}
				lines ++;

				Lock();
				int32 offset = (outputView->outputTextView)->TextLength();
				(outputView->outputTextView)->Insert( offset, msg->FindString("SERVER_REPLY_LINE"), strlen(msg->FindString("SERVER_REPLY_LINE")) );
				Unlock();
				
				break;
			}
		
		case HOW_MANY_MATCHES:
			{
				Lock();
				(outputView->statusBar)->SetMaxValue(msg->FindInt32("HowMany"));
				(outputView->statusBar)->Reset();
				Unlock();
				break;
			}
			
		case NEXT_MATCH:
			{
				Lock();
				int32 offset = (outputView->outputTextView)->TextLength();
				(outputView->outputTextView)->Insert(offset, "--------------------------------------------------------------------------------\n", strlen("--------------------------------------------------------------------------------\n"));
				(outputView->statusBar)->Update(1);
				Unlock();
				break;
			}
		
		case NO_MATCH:
			{
				if (alias_equals)
				{
					alias_equals = false;
				}
				else
				{
					if (strlen(msg->FindString("COMMAND")) <= 8)
					{
						alias_equals = true;
						BMessage *phmsg = new BMessage(QUERY);
						phmsg->AddString("PH_COMMAND", msg->FindString("COMMAND"));
						phmsg->AddBool("RETURN_ALL_STATE", return_all);
						phmsg->AddBool("ALIAS_EQUALS", alias_equals);
	
						Lock();
						(outputView->outputTextView)->SetText("");
						Unlock();
	
						netReq->PostMessage(phmsg);
						delete (phmsg);
		
						request_active = true;
						Lock();
						(outputView->statusView)->SetText("no match found... trying 'alias ='");
						Unlock();
						lines = 0;
					}
				}
				break;
			}
		
		case CONNECTED_TO_SERVER:
			{
				Lock();
				(outputView->statusView)->SetText("idle...");
				Unlock();
				break;
			}
			
		case CONNECT_FAILED:
			{
				Lock();
				(outputView->outputTextView)->SetText("ERROR: Connect Failed.\n");
				Unlock();
				
				request_active = false;
				
				netReq->PostMessage(B_QUIT_REQUESTED);
				break;
			}
		
		case NO_NAME_SERVER:
			{
				Lock();
				(outputView->outputTextView)->SetText("ERROR: Name Lookup Failed for ph Server\n");
				Unlock();
				
				request_active = false;
				
				netReq->PostMessage(B_QUIT_REQUESTED);
				break;
			}
			
		case QUERY_DONE:
			{
				request_active = false;
				Lock();
				(queryView->inputView)->MakeFocus();
				(outputView->statusView)->SetText("idle...");
				(outputView->statusBar)->Reset();
				(outputView->statusBar)->SetMaxValue(1);
				(outputView->statusBar)->Update(1);
				Unlock();
				lines = 0;
				break;
			}
		
		case SHOW_HIDE:
			{
				if (output_view_shown)
				{
					output_view_shown = false;
					old_size = Bounds();
					float outputTextView_Height = (outputView->outputTextView->Bounds()).Height();
					float new_height =  queryView->Bounds().Height() + menuView->Bounds().Height() + B_H_SCROLL_BAR_HEIGHT;
					SetSizeLimits(old_size.Width(), old_size.Width(), new_height, new_height);
					Lock();
					outputView->outputTextView->Hide();
					outputView->scrollView->Hide();
					ResizeTo(old_size.Width(), new_height);
					Unlock();
				}
				else
				{
					SetSizeLimits(old_size.Width(),old_size.Width(),min_height, max_height);
					output_view_shown = true;
					Lock();
					ResizeTo(old_size.Width(), old_size.Height());
					outputView->outputTextView->Show();
					outputView->scrollView->Show();
					Unlock();
				}
				break;
			}
			
		case TEST:
			{
				Lock();
				(outputView->outputTextView)->Insert( msg->FindString("ERROR") );
				(outputView->outputTextView)->Insert("\n");
				Unlock();

				break;
			}
		default:
			{
				inherited::MessageReceived(msg);
				break;
			}
	}
}

char *BephWindow::FindServer(const char *Location_Name)
{
	int count = 0;
	while((strcmp(Location_Name, servers_type[2*count]) != 0) && (count < NUMBER_OF_SERVERS_IN_LIST))
		count++;
	
	if (!strcmp(Location_Name, servers_type[2*count]))
	{
		return servers_type[(2*count) + 1];
	}
	else
	{
		return NULL;
	}
}

void BephWindow::SetLocation_Name(const char *Server)
{
	int count = 0;
	while((strcmp(Server, servers_type[2*count + 1]) != 0) && (count < (NUMBER_OF_SERVERS_IN_LIST - 1)))
		count++;
	
	if (!strcmp(Server, servers_type[2*count + 1]))
	{
		((queryView->serverList->Menu())->ItemAt(count))->SetMarked(true);
	}
}

















